namespace Gen7 {
    [Move effect=HealEachEndOfTurn]
    shared class HealEachEndOfTurn : PkmnScript {
        float _amount;

        void OnInitialize(const narray<EffectParameter@>@ parameters) override{
            _amount = float(parameters[0].AsFloat()) / 100;
        }

        void OnSecondaryEffect(ExecutingMove@, Pokemon@ pokemon, uint8) override {
            auto script = cast<HealEachEndOfTurnEffect>(pokemon.AddVolatile("HealEachEndOfTurn"));
            script.SetBaseHealAmount(_amount);
        }
    }
}