namespace Gen7 {
    namespace CopyableMoves{
        dictionary@ _nonCopyableMoves = {
            {"assist", true},
            {"baneful_bunker", true},
            {"beak_blast", true},
            {"belch", true},
            {"bestow", true},
            {"bounce", true},
            {"celebrate", true},
            {"chatter", true},
            {"circle_throw", true},
            {"copycat", true},
            {"counter", true},
            {"covet", true},
            {"destiny_bond", true},
            {"detect", true},
            {"dig", true},
            {"dive", true},
            {"dragon_tail", true},
            {"endure", true},
            {"feint", true},
            {"fly", true},
            {"focus_punch", true},
            {"follow_me", true},
            {"helping_hand", true},
            {"hold_hands", true},
            {"kings_shield", true},
            {"mat_block", true},
            {"me_first", true},
            {"metronome", true},
            {"mimic", true},
            {"mirror_coat", true},
            {"mirror_move", true},
            {"nature_power", true},
            {"phantom_force", true},
            {"protect", true},
            {"rage_powder", true},
            {"roar", true},
            {"shadow_force", true},
            {"shell_trap", true},
            {"sketch", true},
            {"sky_drop", true},
            {"sleep_talk", true},
            {"snatch", true},
            {"spiky_shield", true},
            {"spotlight", true},
            {"struggle", true},
            {"switcheroo", true},
            {"thief", true},
            {"transform", true},
            {"trick", true},
            {"whirlwind", true}
        };
    
        bool CanCopyMove(const MoveData@ move){
            return !_nonCopyableMoves.exists(move.Name);
        }    
    }
}